<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="项目" prop="item">
        <el-input
          v-model="queryParams.item"
          placeholder="请输入项目"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="danger"
          icon="el-icon-refresh-left"
          size="mini"
          v-if="isApprove==2"
          :disabled="multiple"
          @click="handleTurnDown"
          v-hasPermi="['pssr:subcontent:edit']"
        >驳回
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['pssr:subcontent:export']"
        >导出
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-popover
          placement="top-start"
          trigger="hover">
          <el-table :data="feetList" border>
            <el-table-column width="50" property="index" label="步骤"></el-table-column>
            <el-table-column width="500" property="content" label="检查内容"></el-table-column>
          </el-table>
          <el-button slot="reference"
            size="mini"
            type="success">检查步骤</el-button>
        </el-popover>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table :span-method="mergeMethod" v-loading="loading" :data="subcontentList"
              @selection-change="handleSelectionChange"
              :height="ch" border>
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="部门" align="center" prop="deptUnit" :show-overflow-tooltip="true" width="80"/>
      <el-table-column label="序号" align="center" type="index" :show-overflow-tooltip="true" width="80"/>
      <el-table-column label="项目" align="center" prop="item" :show-overflow-tooltip="true" width="180"/>
      <el-table-column label="开车条件检查内容" align="center" prop="content" :show-overflow-tooltip="true"
                       width="700"/>
      <el-table-column label="审批状态" align="center" prop="approveStatus" width="110">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.pssr_approve_status" :value="scope.row.approveStatus"
                    :show-type="getTagType(scope.row.approveStatus)"/>
        </template>
      </el-table-column>
      <el-table-column label="确认人" align="center" prop="confirmName" :show-overflow-tooltip="true" width="180"/>
      <el-table-column label="确认时间" align="center" prop="confirmationDate" width="150">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.confirmationDate, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remarks" :show-overflow-tooltip="true" width="180"/>
      <el-table-column label="操作" align="center" fixed="right" width="180" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-document-copy"
            @click="gotoSubIndex(scope.row)"
          >检查项
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改开车条件确认对话框 -->
    <el-dialog :close-on-click-modal="false" :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="序号" prop="serialNumber">
          <el-input v-model="form.serialNumber" placeholder="请输入序号"/>
        </el-form-item>
        <el-form-item label="项目" prop="item">
          <el-input v-model="form.item" placeholder="请输入项目"/>
        </el-form-item>
        <el-form-item label="开车条件检查内容">
          <editor v-model="form.content" :min-height="192"/>
        </el-form-item>
        <el-form-item label="确认人" prop="confirm">
          <el-input v-model="form.confirm" placeholder="请输入确认人"/>
        </el-form-item>

        <el-form-item label="备注" prop="remarks">
          <el-input v-model="form.remarks" placeholder="请输入备注"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!-- 用户导入对话框 -->
    <el-dialog :close-on-click-modal="false" :title="upload.title" :visible.sync="upload.open" width="400px"
               append-to-body>
      <el-upload
        ref="upload"
        :limit="1"
        accept=".xlsx, .xls"
        :headers="upload.headers"
        :action="upload.url + '?updateSupport=' + upload.updateSupport"
        :disabled="upload.isUploading"
        :on-progress="handleFileUploadProgress"
        :on-success="handleFileSuccess"
        :auto-upload="false"
        drag
      >
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">
          将文件拖到此处，或
          <em>点击上传</em>
        </div>
        <div class="el-upload__tip" slot="tip">
          <el-checkbox v-model="upload.updateSupport"/>
          是否更新已经存在的用户数据
          <el-link type="info" style="font-size:12px" @click="importTemplate">下载模板</el-link>
        </div>
        <div class="el-upload__tip" style="color:red" slot="tip">提示：仅允许导入“xls”或“xlsx”格式文件！</div>
      </el-upload>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFileForm">确 定</el-button>
        <el-button @click="upload.open = false">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  addSubcontent,
  delSubcontent,
  exportSubcontent,
  getSubcontent,
  handleTurnDownSubcontent,
  importTemplate,
  listSubcontent,
  updateSubcontent,
} from "@/api/pssr/subcontent";
import {treeselect} from "@/api/system/dept";
import {getToken} from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import {getPssrUser} from "@/api/pssr/aboveall";

export default {
  dicts: ['pssr_approve_status'],
  name: "Subcontent",
  components: {Treeselect},
  // components: { Editor },
  props: {
    aboveallId: {
      type: Number,
      default: 0
    },
    isApprove: {
      type: Number,
      default: 0
    },
    clientHeight: {
      type: Number,
      default: 300
    },
    taskType: {
      type: Number,
      default: 0
    }
  },
  data() {
    return {
      ch: this.clientHeight,
      userOptions: [],
      feetList: [
        {index:1, content: "机泵、仪表校验"},
        {index:2, content: "设备清洁度"},
        {index:3, content: "检修项目、设计变更"},
        {index:4, content: "开工方案"},
        {index:5, content: "盲板"},
        {index:6, content: "锁开锁关阀门状态、短接、安全设施、支(吊)架、压力管道/压力容器"},
        {index:7, content: "现场卫生、人身防护、消气防设施、通讯监控、便携式检测仪、环保设施"},
        {index:8, content: "实验室、公用工程、原辅料"},
        {index:9, content: "气密、氮气置换"},
        {index:10, content: "电机设备"},
        {index:11, content: "仪表连锁测试"},
        {index:12, content: "报警/联锁值确认、临时电源、照明电伴热、静电接地/跨接、气体检测仪、在线分析仪"},
      ],
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // 开车条件确认表格数据
      subcontentList: [],
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      // 是否显示弹出层
      open: false,
      openBatch: false,
      // 用户导入参数
      upload: {
        // 是否显示弹出层（用户导入）
        open: false,
        // 弹出层标题（用户导入）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 设置上传的请求头部
        headers: {Authorization: "Bearer " + getToken()},
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/pssr/subcontent/importData"
      },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 50,
        approveId: null,
        aboveallId: null,
        serialNumber: null,
        item: null,
        content: null,
        confirm: null,
        confirmationDate: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        deptId: null,
        taskType: this.taskType,
        remarks: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {}
    };
  },
  watch: {
    // 根据名称筛选部门树
    deptName(val) {
      this.$refs.tree.filter(val);
    }
  },
  created() {
    //设置表格高度对应屏幕高度
    this.$nextTick(() => {
      this.ch = document.body.clientHeight - 250
    })
    const id = this.$route.params.aboveallId || this.aboveallId
    if (typeof id !== 'undefined') {
      this.queryParams.aboveallId = id
    }
    this.getList();
    this.getTreeselect();
    getPssrUser({}).then(res => {
      this.userOptions = res.data
    });
  },
  methods: {
    handleTurnDown(val) {
      this.$confirm('确认驳回？', '提示', {
        confirmButtonText: "确认驳回",
        cancelButtonText: "取消",
      }).then(() => {
        let data = {
          ids: this.ids,
          aboveallId: this.aboveallId
        }
        handleTurnDownSubcontent(data).then(res => {
          this.msgSuccess("驳回成功");
        })
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '取消驳回'
        });
      });
    },
    getTagType(val) {
      if (val == 0) {
        return ''
      } else if (val == 1) {
        return 'warning'
      } else if (val == 2) {
        return 'success'
      }
    },
    gotoSubIndex(row) {
      this.$router.push({name: 'Subitem', params: {subId: row.id, serialNumber: row.forShort}});
    },
    /** 查询开车条件确认列表 */
    getList() {
      this.loading = true;
      listSubcontent(this.queryParams).then(response => {
        this.subcontentList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 查询部门下拉树结构 */
    getTreeselect() {
      treeselect().then(response => {
        this.deptOptions = response.data;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        approveId: null,
        aboveallId: null,
        serialNumber: null,
        item: null,
        content: null,
        confirm: null,
        confirmationDate: null,
        delFlag: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        deptId: null,
        remarks: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加开车条件确认";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getSubcontent(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改开车条件确认";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateSubcontent(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addSubcontent(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return delSubcontent(ids);
      }).then(() => {
        this.getList();
        this.msgSuccess("删除成功");
      })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有开车条件确认数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return exportSubcontent(queryParams);
      }).then(response => {
        window.open(process.env.VUE_APP_BASE_API + response.msg);
      })
    },
    /** 导入按钮操作 */
    handleImport() {
      this.upload.title = "用户导入";
      this.upload.open = true;
    },
    /** 下载模板操作 */
    importTemplate() {
      importTemplate().then(response => {
        this.download(response.msg);
      });
    },
    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert(response.msg, "导入结果", {dangerouslyUseHTMLString: true});
      this.getList();
    },
    // 提交上传文件
    submitFileForm() {
      this.$refs.upload.submit();
    },
    //合并单元格
    mergeMethod({row, column, rowIndex, columnIndex}) {
      if ([1].includes(columnIndex)) {
        const _row = this.setTable(this.subcontentList).merge[rowIndex];
        const _col = _row > 0 ? 1 : 0;
        return {
          rowspan: _row,
          colspan: _col
        };
      }
    },
    //单元格整理
    setTable(tableData) {
      let spanArr = [],
        concat = 0;
      tableData.forEach((item, index) => {
        if (index === 0) {
          spanArr.push(1);
        } else {
          if (item.deptUnit === tableData[index - 1].deptUnit) {
            //第一列需合并相同内容的判断条件
            spanArr[concat] += 1;
            spanArr.push(0);
          } else {
            spanArr.push(1);
            concat = index;
          }
        }
      });
      return {
        merge: spanArr
      };
    },
  }
};
</script>
